
c/* %W%      latest revision %G% %U% */
      subroutine GetIns ()
************************************************************************
c **** This subroutine inputs the job parameters  ***********************

      implicit real*8  ( a-h , o-z )

      real*8   Mp , MN
      character*60 heading

      common /params/   hbarc, pi, Mp, MN, nz, na, nes, nwaves
      common /switch/   nifty(20)
      common /sizes/    achp, acmp, wsp, achn, acmn, wsn
      common /ranges/   rcoul, rcut
      common /inputs/   Tlab , b , ymin1 , ymin2 , xnang,
     $                  kode , lxmax ,  ngp , nr

c *** Open statements are standard FORTRAN 77 and may not be necessary
c *** depending upon the operating system of the machine in which the
c *** code is run.

      open(3,file='tape3',status='unknown',form='unformatted')
c       rhl mod 11/88
      open(5,file='tape5',status='unknown')
      open(6,file='tape6',status='unknown')
      open(7,file='tape7',status='unknown')
      open(8,file='tape8',status='unknown')
      open(9,status='scratch',form='unformatted')
************ tm 08/13/91 open 11 ***************
      open(11,file='tape11',status='unknown')

c *** Mnuc here refers to nucleus mass, MN (in common) to nucleon
c *** read  momenta  in  centre _of_mass
c *** nr <= 0  is  nonrelativistic  nr >= 0 relativistic  case
c ***    >  4  for approximate klein-gordon

      read(5,500)heading
 500  format(a60)
      write(6,600)heading
 600  format(1h ,a60)
      read(5,*) nr, lxmax
c1    format(2i5)
      write(6,605) nr, lxmax
 605  format(1h ,'nr=',i3,'    lmax=',i3)

c *** -------------    read  in  lab  kinetic  energy

      read(5,*) Tlab
      write(6,610) Tlab
 610  format(1h ,'Tlab=',f10.4)
      read(5,*) ngp, kode
      read(5,*) b, xnang, ymin1, ymin2
      write(6,620)ngp,kode,b,xnang,ymin1,ymin2
 620  format(1h ,'ngp=',i3,'  kode=',i3,'  b=',e12.4,'  xnang=',f8.3,
     $ '   ymin1=',f5.2,'   ymin2=',f5.2)
c2    format(6f10.0)
      if (xnang .eq. 0.) then
         xnang = 3.
         write(6,*)' *** xnang changed to 3 ***'
      endif
      if ((ymin1 + ymin2) .eq. 0.) then
         ymin1 = -2.
         ymin2 = -4.
         write(6,*)' *** ymin1 changed to -2, ymin2 changed to -4 ***'
      endif
      if (ngp .le. 0) then
         write(6,*) 'Number of Gauss points cannot be less than one'
         stop
      endif
c     write(6,790) ngp

c *** -----read in data

      read(5,*) achp, acmp, wsp, achn, acmn, wsn, rcoul, rcut
      write(6,630) achp, acmp, wsp, achn, acmn, wsn, rcoul, rcut
 630  format(1h ,'achp=',f7.4,'  acmp=',f7.4,'  wsp=',f7.4,
     $ '  achn=',f7.4,'  acmn=',f7.4,'  wsn=',f7.4/
     $ 1h ,' rcoul=',f7.4,'   rcut=',f7.4)
      read(5,*) nz, na
      read(5,*) (nifty(n),n=1,20)
c3    format(20i2)
      write(6,640) nz, na, (nifty(n),n=1,20)
 640  format(1h ,'nz=',i3,'  na=',i3,'   nifty=',4(1x,5I1))

      read(5,*) nes, nwaves
      write(6,650) nes, nwaves
 650  format(1h ,'nes=',i5,'   nwaves=',i3)

c omit coulomb effects for neutron and cex calculations
      if(nifty(1).eq.9)then
      write(6,6055)'neutron'
 6055 format(/1h ,' *** nifty(10) set to 0 (no coul) for ',A8,' ***'/)
      nifty(10)=0
      else if(nifty(1).eq.-2.and.nifty(10).ne.0)then
      write(6,6056)' Cex   '
 6056 format(/1h ,' ***',a8,'with coulomb distorted p amplitude'/)
      endif

c *** print out nifty ***

      call PRNIF()

c *** Square input size parameters for He3 (prevoius read in squared)

      if (na .eq. 3) then
         achp = achp * achp
         acmp = acmp * acmp
         wsp = wsp * wsp
         achn = achn * achn
         acmn = acmn * acmn
         wsn = wsn * wsn
         write(6,*)' *** input sized parameters squared for He3 ***'
         write(6,630) achp, acmp, wsp, achn, acmn, wsn
      endif

      RETURN

c *** format statements ***

 790  format (1h ,18hno of grid points=,i4)

      end
