c/* %W%      latest revision %G% %U% */
      subroutine PLPRME (x, Plp, n)
c***********************************************************************

c *** PLPRME calculates the derivative of the Legrendre polynomials.
c *** It now uses the formulae of Jackson directly by dimensioning the
c *** array Plp from 0 to 49.

c *** INPUT ARGUMENTS
c ***    x   = cos(theta)
c ***    Plp = array containing the Pl primes evaluated at x
c ***    n   = number of Pl primes the calling program wants
c ***

      implicit real*8 (a-h, o-z)
      dimension Plp(0:99)

c >>> FIRST EXECUTABLE STATEMENT <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      Plp(0) = 0.0
      Plp(1) = 1.0
      IF (n .gt. 2) then
         nn = n - 2
         do 10 l = 1,nn
            Plp(l+1) = ( (2*l+1)*x*Plp(l) - (l+1)*Plp(l-1) )/l
  10     continue
      endif
      return
      end
